 REM Fours v1.2a expression parser. Calculates fours problem.

 DECLARE SUB Arith (T$, T1#, T2#)
 DECLARE SUB Equate ()
 DECLARE SUB Get.Token ()
 DECLARE SUB Parse1 (T#)
 DECLARE SUB Parse2 (T#)
 DECLARE SUB Parse3 (T#)
 DECLARE SUB Parse4 (T#)
 DECLARE SUB Parse5 (T#)

 COMMON SHARED Counter AS DOUBLE, Error.Num AS INTEGER
 COMMON SHARED Out2 AS STRING, Out3 AS STRING, Display.Solution AS INTEGER
 COMMON SHARED Solutions() AS STRING * 32, Strng AS STRING
 COMMON SHARED Token.Index AS INTEGER, Token.Type AS INTEGER
 COMMON SHARED Total.Solutions AS INTEGER, MaxCalc AS INTEGER

 ON ERROR GOTO Error.Routine
Start.Input:
 PRINT "Enter solutions to search for(24-8192)";
 INPUT X
 X = INT(X)
 IF X >= 24 AND X <= 8192 THEN
    GOTO Start.Calc
 ELSE
    GOTO Start.Input
 END IF
Start.Calc:
 MaxCalc = X
 REDIM Solutions(1 TO MaxCalc) AS STRING * 32
 Display.Solution = -1 ' set to true to display solutions
 STACK 4096 ' increase stack for recursion
 COLOR 15, 0
 CLS
 PRINT "Fours v1.2a: Calculates fours problem;"
 COLOR 14, 0
 PRINT "Calculating: ";
 COLOR 15, 0
 a$ = "-+/*^" ' token list
 FOR P = 1 TO 17
    IF Display.Solution THEN
       PRINT
       COLOR 14, 0
       PRINT "Solution set:"; P; "of"; 17
       COLOR 15, 0
    END IF
    FOR L = 1 TO 5
       FOR M = 1 TO 5
          FOR N = 1 TO 5
             SELECT CASE P
             CASE 1 ' 4/4/4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 2 ' (4/4)+4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "(" + Q1$ + MID$(a$, L, 1) + Q2$ + ")" + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "(" + R1$ + MID$(a$, L, 1) + R2$ + ")" + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 3 ' 4/(4+4)/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = Q1$ + MID$(a$, L, 1) + "(" + Q2$ + MID$(a$, M, 1) + Q3$ + ")" + MID$(a$, N, 1) + Q4$
                            Out3 = R1$ + MID$(a$, L, 1) + "(" + R2$ + MID$(a$, M, 1) + R3$ + ")" + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 4 ' 4/(4/4/4)
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = Q1$ + MID$(a$, L, 1) + "(" + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$ + ")"
                            Out3 = R1$ + MID$(a$, L, 1) + "(" + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$ + ")"
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 5 ' (4/4/4)/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "(" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + ")" + MID$(a$, N, 1) + Q4$
                            Out3 = "(" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + ")" + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 6 ' -4/4+4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "-" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 7 ' -(4/4)/4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-(" + Q1$ + MID$(a$, L, 1) + Q2$ + ")" + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "-(" + R1$ + MID$(a$, L, 1) + R2$ + ")" + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 8 ' -4/(4/4)/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-" + Q1$ + MID$(a$, L, 1) + "(" + Q2$ + MID$(a$, M, 1) + Q3$ + ")" + MID$(a$, N, 1) + Q4$
                            Out3 = "-" + R1$ + MID$(a$, L, 1) + "(" + R2$ + MID$(a$, M, 1) + R3$ + ")" + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 9 ' -(4/4/4)/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-(" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + ")" + MID$(a$, N, 1) + Q4$
                            Out3 = "-(" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + ")" + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 10 ' not(4)/4/4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "not(" + Q1$ + ")" + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "!(" + R1$ + ")" + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 11 ' not(4/4)/4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "not(" + Q1$ + MID$(a$, L, 1) + Q2$ + ")" + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "!(" + R1$ + MID$(a$, L, 1) + R2$ + ")" + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 12 ' not(4/4/4)/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "not(" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + ")" + MID$(a$, N, 1) + Q4$
                            Out3 = "!(" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + ")" + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 13 ' not(4/4/4/4)
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "not(" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$ + ")"
                            Out3 = "!(" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$ + ")"
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 14 ' -not(4)/4/4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-not(" + Q1$ + ")" + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "-!(" + R1$ + ")" + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 15 ' -not(4/4)/4/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-not(" + Q1$ + MID$(a$, L, 1) + Q2$ + ")" + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$
                            Out3 = "-!(" + R1$ + MID$(a$, L, 1) + R2$ + ")" + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 16 ' -not(4/4/4)/4
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-not(" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + ")" + MID$(a$, N, 1) + Q4$
                            Out3 = "-!(" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + ")" + MID$(a$, N, 1) + R4$
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             CASE 17 ' -not(4/4/4/4)
                FOR Q1 = 1 TO 4
                   FOR Q2 = 1 TO 4
                      FOR Q3 = 1 TO 4
                         FOR Q4 = 1 TO 4
                            SELECT CASE Q1
                            CASE 1
                               Q1$ = "4": R1$ = "4"
                            CASE 2
                               Q1$ = "sqr(4)": R1$ = CHR$(251) + "4"
                            CASE 3
                               Q1$ = "fct(4)": R1$ = "4!"
                            CASE 4
                               Q1$ = "not(4)": R1$ = "!(4)"
                            END SELECT
                            SELECT CASE Q2
                            CASE 1
                               Q2$ = "4": R2$ = "4"
                            CASE 2
                               Q2$ = "sqr(4)": R2$ = CHR$(251) + "4"
                            CASE 3
                               Q2$ = "fct(4)": R2$ = "4!"
                            CASE 4
                               Q2$ = "not(4)": R2$ = "!(4)"
                            END SELECT
                            SELECT CASE Q3
                            CASE 1
                               Q3$ = "4": R3$ = "4"
                            CASE 2
                               Q3$ = "sqr(4)": R3$ = CHR$(251) + "4"
                            CASE 3
                               Q3$ = "fct(4)": R3$ = "4!"
                            CASE 4
                               Q3$ = "not(4)": R3$ = "!(4)"
                            END SELECT
                            SELECT CASE Q4
                            CASE 1
                               Q4$ = "4": R4$ = "4"
                            CASE 2
                               Q4$ = "sqr(4)": R4$ = CHR$(251) + "4"
                            CASE 3
                               Q4$ = "fct(4)": R4$ = "4!"
                            CASE 4
                               Q4$ = "not(4)": R4$ = "!(4)"
                            END SELECT
                            Out2 = "-not(" + Q1$ + MID$(a$, L, 1) + Q2$ + MID$(a$, M, 1) + Q3$ + MID$(a$, N, 1) + Q4$ + ")"
                            Out3 = "-!(" + R1$ + MID$(a$, L, 1) + R2$ + MID$(a$, M, 1) + R3$ + MID$(a$, N, 1) + R4$ + ")"
                            CALL Equate
                            IF Total.Solutions = MaxCalc THEN
                               GOTO End.Program
                            END IF
                         NEXT
                      NEXT
                   NEXT
                NEXT
             END SELECT
          NEXT
       NEXT
    NEXT
 NEXT
End.Program:
 OPEN "fours.txt" FOR OUTPUT AS #1
 FOR L = 1 TO MaxCalc
    X$ = RTRIM$(Solutions(L))
    IF X$ = STRING$(32, 0) THEN
       PRINT #1, "<none>="; L
    ELSE
       PRINT #1, X$; "="; L
    END IF
 NEXT
 CLOSE
 PRINT
 COLOR 14, 0
 PRINT MID$(STR$(Counter), 2); " calculations complete."
 PRINT MID$(STR$(Total.Solutions), 2); " solutions of"; MaxCalc; "found."
 PRINT "Solutions written to fours.txt"
 COLOR 7, 0
 END

Error.Routine:
 ' overflow
 IF ERR = 6 THEN
    RESUME NEXT
 END IF
 ' division by zero
 IF ERR = 11 THEN
    RESUME NEXT
 END IF
 ' illegal function call
 IF ERR = 5 THEN
    RESUME NEXT
 END IF
 PRINT "Fatal error "; ERR
 END
END

 ' routine accepts an operation and performs on two values
SUB Arith (Token.Parsed$, Temp#, Temp2#)
 ON ERROR GOTO Error.Routine
 SELECT CASE Token.Parsed$
 CASE "-"
    Temp# = Temp# - Temp2#
 CASE "+"
    Temp# = Temp# + Temp2#
 CASE "/"
    Temp# = Temp# / Temp2#
 CASE "*"
    Temp# = Temp# * Temp2#
 CASE "^"
    Temp# = Temp# ^ Temp2#
 END SELECT
END SUB

 ' entry to expression parser
SUB Equate
 ON ERROR GOTO Error.Routine
 Out2 = UCASE$(Out2)
 Position = INSTR(Out2, " ") ' locate imbedded spaces
 WHILE Position ' loop until spaces removed
    Out2 = LEFT$(Out2, Position - 1) + MID$(Out2, Position + 1)
    Position = INSTR(Out2, " ") ' get next space
 WEND
 Counter = Counter + 1
 Error.Num = 0
 Temp# = False ' reset result
 Token.Index = 1 ' reset pointer to expression token
 CALL Get.Token ' read next token
 CALL Parse1(Temp#) ' entry to parse the expression
 IF Error.Num THEN
    EXIT SUB
 END IF
 IF Temp# < 0# THEN
    EXIT SUB
 END IF
 IF INT(Temp#) <> Temp# THEN
    EXIT SUB
 END IF
 IF Temp# >= 1 AND Temp# <= MaxCalc THEN
    IF ASC(LEFT$(Solutions(Temp#), 1)) = 0 THEN
       PRINT Temp#;
       IF Display.Solution THEN
          PRINT "= "; Out3
       END IF
       Solutions(Temp#) = Out3
       Total.Solutions = Total.Solutions + 1
    END IF
 END IF
END SUB

SUB Get.Token
 ON ERROR GOTO Error.Routine
 Strng = "" ' reset token
 Token.Type = 0 ' reset token type
 IF Token.Index > LEN(Out2) THEN ' compare pointer at end of expression
    EXIT SUB
 END IF
 ' locate expression symbol
 IF INSTR("-+*/^()", MID$(Out2, Token.Index, 1)) THEN
    Strng = MID$(Out2, Token.Index, 1) ' store token
    Token.Index = Token.Index + 1 ' increment pointer
    Token.Type = 1 ' store token type
    EXIT SUB
 END IF
 ' locate expression is number
 IF MID$(Out2, Token.Index, 1) >= "0" AND MID$(Out2, Token.Index, 1) <= "9" THEN
    ' increment token until token is other than number
    WHILE INSTR("-+*/^()", MID$(Out2, Token.Index, 1)) = False
       Strng = Strng + MID$(Out2, Token.Index, 1)
       Token.Index = Token.Index + 1
    WEND
    Token.Type = 2 ' store token type
    EXIT SUB
 END IF
 ' locate expression is alphabetic
 IF MID$(Out2, Token.Index, 1) >= "A" AND MID$(Out2, Token.Index, 1) <= "Z" THEN
    ' increment token until token is other than alphabetic
    WHILE INSTR("-+*/^()", MID$(Out2, Token.Index, 1)) = False
       Strng = Strng + MID$(Out2, Token.Index, 1)
       Token.Index = Token.Index + 1
    WEND
    Token.Type = 3 ' store token type
    EXIT SUB
 END IF
END SUB

 ' addition/subtraction parser
SUB Parse1 (Temp#)
 ON ERROR GOTO Error.Routine
 CALL Parse2(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 WHILE Token.Parsed$ = "+" OR Token.Parsed$ = "-"
    CALL Get.Token ' read next token
    CALL Parse2(Temp2#) ' get next operator
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 WEND
END SUB

 ' multiplication/division parser
SUB Parse2 (Temp#)
 ON ERROR GOTO Error.Routine
 CALL Parse3(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 WHILE Token.Parsed$ = "*" OR Token.Parsed$ = "/"
    CALL Get.Token ' read next token
    CALL Parse3(Temp2#) ' get next operator
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 WEND
END SUB

 ' power parser
SUB Parse3 (Temp#)
 ON ERROR GOTO Error.Routine
 CALL Parse4(Temp#) ' get next operator precedence
 Token.Parsed$ = Strng ' store token
 ' process token
 WHILE Token.Parsed$ = "^"
    CALL Get.Token ' read next token
    CALL Parse4(Temp2#) ' get next operator
    CALL Arith(Token.Parsed$, Temp#, Temp2#) ' calculate expression
    Token.Parsed$ = Strng ' store next token
 WEND
END SUB

' unary parser
SUB Parse4 (Temp#)
 ON ERROR GOTO Error.Routine
 Token.Parsed$ = Strng ' store token
 ' process token
 IF Token.Parsed$ = "-" THEN
    CALL Get.Token
 END IF
 CALL Parse5(Temp#) ' get next operator
 IF Token.Parsed$ = "-" THEN
    Temp# = -Temp#
 END IF
END SUB

SUB Parse5 (Temp#)
 ON LOCAL ERROR GOTO Error.Routine2
 SELECT CASE Token.Type ' check token type
 CASE 1 ' token is symbol
    SELECT CASE Strng ' determine token
    CASE "(" ' calculate opening parenthesis
       CALL Get.Token ' read next token value inside parenthesis
       DO ' calculate value
          CALL Parse1(Temp#) ' call parse entry recursively
       LOOP UNTIL Strng = ")" OR Token = 0 ' check closing parenthesis
       CALL Get.Token ' read next token after parenthesis
    CASE ")" ' check token is closing parenthesis
       CALL Get.Token ' read next token after parenthesis
       EXIT SUB
    END SELECT
 CASE 2 ' token is numeric value
    Temp# = VAL(Strng) ' calculate value
    CALL Get.Token ' read next token after number
 CASE 3 ' token type is alphabetic
    SELECT CASE Strng
    CASE "NOT" ' boolean not
       CALL Get.Token
       CALL Get.Token
       CALL Parse1(Temp#)
       IF Temp# <> INT(Temp#) THEN
          Error.Num = 5
          EXIT SUB
       END IF
       Temp# = NOT (Temp#)
    CASE "SQR" ' square root
       CALL Get.Token
       CALL Get.Token
       CALL Parse1(Temp#)
       IF Temp# <> INT(Temp#) THEN
          Error.Num = 5
          EXIT SUB
       END IF
       Temp# = SQR(Temp#)
    CASE "FCT" ' calculate xth factorial
       CALL Get.Token
       CALL Get.Token
       CALL Parse1(Temp#)
       Factorial.Count# = Temp#
       IF Factorial.Count <> INT(Factorial.Count) THEN
          Error.Num = 5
          EXIT SUB
       END IF
       IF Factorial.Count <= 0 THEN
          Error.Num = 5
          EXIT SUB
       END IF
       Factorial# = 1 ' reset factorial
       FOR Count# = 1 TO Factorial.Count# ' compute xth value
          Factorial# = Factorial# * Count# ' compute value
       NEXT
       Temp# = Factorial# ' assign result
    END SELECT
    CALL Get.Token ' read next token
 END SELECT
Error.Resume2:
 EXIT SUB
Error.Routine2:
 Error.Num = ERR
 RESUME Error.Resume2
END SUB

